//----------------------------------------------------------------
// GUI Frame 
// Programmr: Bjrk Busch nov.2001/2002
//----------------------------------------------------------------

import javabook.Convert;
import java.awt.*;
import java.awt.event.*;

public	class GuiDialog extends Dialog
{
  // Skrmdata

  private Label      	dataLabel   = new Label ("data:");
  private TextField   dataField   = new TextField ("",50);

  private Label       ekstraLabel = new Label ("data til/fra dialog:");
  private TextField   ekstraField = new TextField ("",50);

  private Button      hentKnap    = new Button("Hent data fra");
  private Button      retKnap     = new Button("Ret data i model");
  private Button      lukKnap     = new Button("Luk dialog");

  // Modelkomponent 
  ModelKlasse		model;


  public GuiDialog (Frame frame, boolean modal, ModelKlasse	model)			/* constructor */
  {

    super(frame, modal);
    this.model = model;		// gem reference til model til senere brug

    // opbygning af skrmbillede
    setSize(700,200);
    if (modal)
      setTitle("Modal Dialog adgang til Global.model  -  Systemeksempel udarbejdet af Bjrk Busch");
    else
      setTitle("Modles Dialog adgang til Global.model  -  Systemeksempel udarbejdet af Bjrk Busch");

    setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));		

    add(dataLabel);
    add(dataField);
    add(ekstraLabel);
    add(ekstraField);

    add(hentKnap);
    hentKnap.addActionListener(new HentKnapActionListener());

    add(retKnap);
    retKnap.addActionListener(new RetKnapActionListener());

    add(lukKnap);
    lukKnap.addActionListener(new LukKnapActionListener());

    addWindowListener(new DisposeWindowClosingListener());
  }

  public	void	overfoerDataTilDialog(String ekstra)
  {
    ekstraField.setText(ekstra);
  }

  public	String	overfoerDataFraDialog()
  {
    return ekstraField.getText();
  }

  private	void hent()
  {
    dataField.setText(""+model.getData());
  }
  private	void ret()
  {
    model.setData(dataField.getText());
  }

  private	void luk()
  {
    this.dispose();
  }

  //=============================================================================
  // event-handlere
  private	class HentKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      hent();
    }
  }
  private	class RetKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      ret();
    }
  }
  private	class LukKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      luk();
    }
  }
  private class DisposeWindowClosingListener extends WindowAdapter
  {
    public void windowClosing(WindowEvent e)
    {
      e.getWindow().dispose();  // lukker det window som "lytter" er knyttet til
    }
  }
} // slut p dialog-klasse

