//----------------------------------------------------------------
// GUI main Frame
// Programmr: Bjrk Busch nov.2001/2002
//----------------------------------------------------------------

import javabook.Convert;
import java.awt.*;
import java.awt.event.*;

public	class GuiMainFrame extends Frame
{
  // Skrmdata
  private MenuBar   menuBar             =	new MenuBar();
  private Menu      menuTing            =	new Menu("Afprvningsmuligheder");
  private MenuItem  itemNyFrame         =	new MenuItem("Ny EkstraFrame med adgang til Global.model");
  private MenuItem  itemFastFrame       =	new MenuItem("Aktiver fast EkstraFrame med adgang til Global.model");
  private MenuItem  itemfastDialog      =	new MenuItem("Aktiver fast Dialog med adgang til Global.model");
  private MenuItem  itemNyModalDialog   =	new MenuItem("Aktiver ny Modal Dialog med adgang til Global.model");
  private MenuItem  itemNyModlesDialog	=	new MenuItem("Aktiver ny Modles Dialog med adgang til Global.model");

  // Guikomponent 
  private GuiEkstraFrame  fastEkstraFrame;
  private GuiDialog       fastDialog;


  // Modelkomponent 
  ModelKlasse		model;


  public GuiMainFrame ()			/* constructor */
  {
  	// opret en model
  	model	= 	new ModelKlasse("Start tekst for model");

    // opbygning af skrmbillede
    setSize(600,200);
    setTitle("Model med GUI - Global.model og guidata udveksles mellem flere frame's og dialog'er  -  Systemeksempel udarbejdet af Bjrk Busch");

    setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));		

    setMenuBar(menuBar);

    menuBar.add(menuTing);

    menuTing.add(itemNyFrame);
    itemNyFrame.addActionListener(new NyEkstraFrameActionListener());

    menuTing.add(itemFastFrame);
    itemFastFrame.addActionListener(new FastEkstraFrameActionListener());

    menuTing.add(itemfastDialog);
    itemfastDialog.addActionListener(new FastDialogActionListener());

    menuTing.add(itemNyModalDialog);
    itemNyModalDialog.addActionListener(new NyModalDialogActionListener());

    menuTing.add(itemNyModlesDialog);
    itemNyModlesDialog.addActionListener(new NyModlesDialogActionListener());


    fastEkstraFrame  = new GuiEkstraFrame (model);  // opret og Gem reference til denne
    fastEkstraFrame.addWindowListener	( new DisposeWindowClosingListener() );
    fastEkstraFrame.setVisible(true);

    fastDialog  = new GuiDialog (this, true, model);  // opret og Gem reference til denne

  }

  private	void opretNyEkstraFrame ()
  {
      GuiEkstraFrame ekstraFrame  = new GuiEkstraFrame (model);
      ekstraFrame.addWindowListener	( new DisposeWindowClosingListener() );
      ekstraFrame.setVisible(true);
  }

  private	void aktiverFastEkstraFrame ()
  {
    fastEkstraFrame.setVisible(true);
  }

  private	void aktiverFastDialog ()
  {
    fastDialog.overfoerDataTilDialog("Data fra mainFrame: "+model.getData());
    fastDialog.show();
    System.out.println("Retur fra Global.fastDialog: "+fastDialog.overfoerDataFraDialog());
  }

  private	void opretNyModalDialog ()
  {
    GuiDialog  nyDialog = new GuiDialog (this, true, model);
    nyDialog.overfoerDataTilDialog("Data fra mainFrame 1.gang: "+model.getData());
    nyDialog.show();
    System.out.println("Retur fra ny Modal Dialog: "+nyDialog.overfoerDataFraDialog());

    nyDialog.overfoerDataTilDialog("Data fra mainFrame 2.gang: "+model.getData());
    nyDialog.show();
    System.out.println("Retur fra ny Modal Dialog: "+nyDialog.overfoerDataFraDialog());
  }

  private	void opretNyModlesDialog ()
  {
    GuiDialog  nyDialog = new GuiDialog (this, false, model);
    nyDialog.overfoerDataTilDialog("Data fra mainFrame 1.gang: "+model.getData());
    nyDialog.show();
    System.out.println("Retur fra ny Modles Dialog: "+nyDialog.overfoerDataFraDialog());
  }


  //=============================================================================
  // event-handlere
  private	class NyEkstraFrameActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      opretNyEkstraFrame();
    }
  }
  private	class FastEkstraFrameActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      aktiverFastEkstraFrame ();
    }
  }
  private	class FastDialogActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      aktiverFastDialog ();
    }
  }
  private	class NyModalDialogActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      opretNyModalDialog ();
    }
  }
  private	class NyModlesDialogActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      opretNyModlesDialog ();
    }
  }
  private class DisposeWindowClosingListener extends WindowAdapter
  {
    public void windowClosing(WindowEvent e)
    {
      e.getWindow().dispose();  // lukker det window som "lytter" er knyttet til
    }
  }


} // slut p frame-klasse